# MapReduce-PageRank

This package is a MapReduce based implementation of parallel PageRank computation in Haskell.

## How to boot the package

1. Install Haskell Tool Stack following [haskell stack doc](https://docs.haskellstack.org/en/stable/README/)

2. Go to the root directory of `MapReduce-PageRank` package (should be same dir as this README.md)

3. `stack setup`

4. `stack build`

5. To run the executable, `stack exec -- MapReduce-PageRank-exe <inputfilePath> <outputfilePath> <numberOfIterations> [computationMode]`, for example `stack exec -- MapReduce-PageRank-exe ../data/sample_input.txt ../data/sample_output.txt 5`

> `[computationMode]` is an optional argument, can be one of {seq, mr_def, mr_ext}. 
> 
> seq: non-parallel sequential computation
> 
> mr_def: parallel implementation based on default MapReduce
> 
> mr_ext: benchmark parallel implementation based on external opensourced MapReduce library

6. To control the number of threads being used, `stack exec -- MapReduce-PageRank-exe <inputfilePath> <outputfilePath> <numberOfIterations> [computationMode] +RTS -N[?]`

## Evaluation

`../data/input.txt` is a network dataset with interesting size. The dataset comes from a network which contains all the Wikipedia voting data from the inception of Wikipedia till January 2008. Nodes in the network represent wikipedia users and a directed edge from node i to node j represents that user i voted on user j. The original network has 103689 edges, `../data/input.txt` contains 11515 edges therein.
