module MapReduce
( mapReduce )

where

import Control.Parallel (pseq)
import Control.Parallel.Strategies (rpar, runEval, parMap)

mapReduce :: 
    (a -> b)         -- map function
    -> ([b] -> c)    -- reduce function
    -> [a]           -- list to map over
    -> c
mapReduce mapper reducer input = pseq mapResult reduceResult
  where mapResult = parMap rpar mapper input
        reduceResult = runEval (rpar $ reducer mapResult)
