{-

    This module contains a utility function, which
    1) reads in a graph from a input file
    2) initializes a PageRank data from the given graph
    3) returns the graph and the initial page rank

-}

module ProcessData
(processData) where

import Graph (Graph, fromFile)
import PageRank (PageRank, initFromGraph)

processData :: String -> IO (Graph, PageRank)
processData filename = do
    graph <- fromFile filename
    let pageRank = initFromGraph graph
    return (graph, pageRank)
